## nodejs 18.19.0%2Bdfsg

=== debian/changelog ===
nodejs (18.19.0+dfsg-6) unstable; urgency=medium

  * patch: remove useless and badly done icu_74 patch

 -- Jérémy Lal <kapouer@melix.org>  Sun, 03 Dec 2023 22:41:14 +0100

nodejs (18.19.0+dfsg-5) unstable; urgency=medium

  * patch: disable openssl test that depends on error message format

 -- Jérémy Lal <kapouer@melix.org>  Sun, 03 Dec 2023 22:41:00 +0100

nodejs (18.19.0+dfsg-4) unstable; urgency=medium

  * patch:
    + remove a failed attempt for test dns-resolveany-bad-ancount
      skip it, it uselessly hangs.
    + disable some icu test to allow transition to 74
    + fix test-crypto-dh.js to pass with openssl 3.0.11, 3.1.4
    + riscv64: some tests have been fixed, but new ones fail

 -- Jérémy Lal <kapouer@melix.org>  Sun, 03 Dec 2023 15:00:35 +0100

nodejs (18.19.0+dfsg-3) unstable; urgency=medium

  * patch: drop fixed openssl test patch
  * patch: allow bad-ancount test to fail

 -- Jérémy Lal <kapouer@melix.org>  Sat, 02 Dec 2023 02:12:25 +0100

nodejs (18.19.0+dfsg-2) unstable; urgency=medium

  * patch: fix test_dns_resolveany_bad_ancount_timeout.patch

 -- Jérémy Lal <kapouer@melix.org>  Fri, 01 Dec 2023 19:07:23 +0100

nodejs (18.19.0+dfsg-1) experimental; urgency=medium

  [ Jérémy Lal ]
  * New upstream version 18.19.0+dfsg
    + tests pass with openssl 3.1, closes: #1055416
    + tests pass with libc-ares >= 1.23.0, closes: #1054690
  * Harmonize stack size patch for arm64. Closes: 1030284
  * Install dir usr/lib/<tripler>/nodejs. Fix #1035463
  * No longer force gcc 11 for sid
  * Fix Vcs fields to point to the right branch
  * builtins: set correct version in builtins headers
  * dfsg-exclude for non-preferred form for modification:
    + deps/ada
    + deps/minimatch
    + test/fixtures/postject-copy
  * component: ./ada
  * copyright:
    + add missing authors to histogram
    + drop unnecessary snapshot.blob exclusion
    + licenses for ada
    + deps/cares now using Expat
    + document some new files
  * patches:
    + test-process-versions must use system versions
    + drop the test using postject
    + build using ada component instead of deps/ada
    + minimatch is actually not needed for build
    + fix test-runner-output, forwarded
    + mark parallel/test-debugger-preserve-breaks as flaky,
      it is failing in sbuild for now
    + fix test-dns-resolveany-bad-ancount to work with c-ares,
      also to not hang the testsuite in sbuild

  [ Yadd ]
  * Declare compliance with policy 4.6.2

 -- Jérémy Lal <kapouer@melix.org>  Fri, 01 Dec 2023 01:23:44 +0100

## nodejs 18.19.0+dfsg

=== debian/changelog ===
nodejs (18.19.0+dfsg-6~deb12u2) bookworm; urgency=medium

  * Non-maintainer upload.
  * Skip failing tests on MIPS.

 -- Adrian Bunk <bunk@debian.org>  Sat, 22 Jun 2024 15:21:29 +0300

nodejs (18.19.0+dfsg-6~deb12u1) bookworm-security; urgency=medium

  * Upstream update.
  * CVE-2023-23918: Permissions policies can be bypassed via
    process.mainModule. Closes #1031834.
  * CVE-2023-23919: OpenSSL error handling issues in nodejs crypto
    library. Closes: #1031834.
  * CVE-2023-23920: Insecure loading of ICU data through ICU_DATA
    environment variable. Closes: #1031834.
  * CVE-2023-30590: DiffieHellman do not generate keys after setting a
    private key. Closes: #1039990.
  * CVE-2023-30589: HTTP Request Smuggling via Empty headers separated by CR.
    Closes: #1039990.
  * CVE-2023-30588: Process interuption due to invalid Public Key information
    in x509 certificates. Closes: #1039990.
  * CVE-2023-32559: Permissions policies can be bypassed via process.binding.
    Closes: #1050739.
  * CVE-2023-30581: mainModule.proto bypass experimental policy mechanism.
    Closes: #1039990.
  * CVE-2023-32002: Permissions policies can be bypassed via Module._load.
    Closes: #1050739.
  * CVE-2023-32006: Permissions policies can impersonate other modules in
    using module.constructor.createRequire(). Closes: #1050739.
  * CVE-2023-38552: Integrity checks according to policies can be
    circumvented. Closes: #1054892.
  * CVE-2023-39333: Code injection via WebAssembly export names.
    Closes: #1054892.

 -- Jérémy Lal <kapouer@melix.org>  Wed, 20 Dec 2023 18:07:36 +0100

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildtools.mk


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

builtins := /usr/share/nodejs/node

# source equivalent of nodejs -e 'console.log(process.versions.modules)'
ABI = $(shell awk '/^#define NODE_MODULE_VERSION/ {print $$3}' src/node_version.h)

# archs
ARCHS := amd64 arm64 armel armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el riscv64 s390x

# branch
BRANCH := $(word 1, $(subst .,$(space), $(DEB_UPSTREAM_VERSION)))

LANG=C
export LANG
DEB_CONFIGURE_NORMAL_ARGS =
DEB_CONFIGURE_EXTRA_FLAGS = \
--verbose \
--without-npm \
--without-corepack \
--shared \
--shared-zlib \
--shared-cares \
--shared-nghttp2 \
--shared-brotli \
--shared-builtin-undici/undici-path=/usr/share/nodejs/undici/undici-fetch.js \
--shared-builtin-acorn-path=/usr/share/nodejs/acorn/dist/acorn.js \
--shared-builtin-acorn_walk-path=/usr/share/nodejs/acorn-walk/dist/walk.js \
--shared-builtin-cjs_module_lexer/lexer-path=/usr/share/nodejs/cjs-module-lexer/lexer.js \
--shared-builtin-cjs_module_lexer/dist/lexer-path=/usr/share/nodejs/cjs-module-lexer/dist/lexer.js \
--with-intl=system-icu \
--prefix=/usr \
--shared-openssl \
--openssl-use-def-ca-store \
--arch-triplet=$(DEB_HOST_MULTIARCH) \
--node-relative-path="lib/$(DEB_HOST_MULTIARCH)/nodejs:share/nodejs" \
--shared-libuv

ifneq ($(filter pkg.nodejs.nobuiltin,$(DEB_BUILD_PROFILES)),)
	DEB_CONFIGURE_EXTRA_FLAGS += --node-builtin-modules-path=$(builtins)
endif

# map HOST ARCH AND OS, and if unknown let upstream guess

destCpu =
destCpu := $(or $(destCpu),$(if $(filter i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter x32,$(DEB_HOST_ARCH)),x32))
destCpu := $(or $(destCpu),$(if $(filter kfreebsd-i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter hurd-i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter amd64,$(DEB_HOST_ARCH)),x64))
destCpu := $(or $(destCpu),$(if $(filter kfreebsd-amd64,$(DEB_HOST_ARCH)),x64))
destCpu := $(or $(destCpu),$(if $(filter armel,$(DEB_HOST_ARCH)),arm))
destCpu := $(or $(destCpu),$(if $(filter armhf,$(DEB_HOST_ARCH)),arm))
destCpu := $(or $(destCpu),$(if $(filter aarch64,$(DEB_HOST_ARCH)),arm64))
destCpu := $(or $(destCpu),$(if $(filter mipsel,$(DEB_HOST_ARCH)),mipsel))
destCpu := $(or $(destCpu),$(if $(filter mips64el,$(DEB_HOST_ARCH)),mips64el))
destCpu := $(or $(destCpu),$(if $(filter mips64r6el,$(DEB_HOST_ARCH)),mips64el))
destCpu := $(or $(destCpu),$(if $(filter mips,$(DEB_HOST_ARCH)),mips))
destCpu := $(or $(destCpu),$(if $(filter powerpc,$(DEB_HOST_ARCH)),ppc))
destCpu := $(or $(destCpu),$(if $(filter ppc64,$(DEB_HOST_ARCH)),ppc64))
destCpu := $(or $(destCpu),$(if $(filter riscv64,$(DEB_HOST_ARCH)),riscv64))
destCpu := $(or $(destCpu),$(if $(filter s390x,$(DEB_HOST_ARCH)),s390x))

# solaris freebsd openbsd linux
destOs =
destOs := $(or $(destOs),$(if $(filter linux,$(DEB_HOST_ARCH_OS)),linux))
destOs := $(or $(destOs),$(if $(filter kfreebsd,$(DEB_HOST_ARCH_OS)),freebsd))

ifneq (, $(destOs))
DEB_CONFIGURE_EXTRA_FLAGS += --dest-os=$(destOs)
endif
ifeq (unsupported, $(destCpu))
$(error "nodejs cannot run on $(DEB_HOST_ARCH), please consult maintainers")
endif
ifneq (, $(destCpu))
DEB_CONFIGURE_EXTRA_FLAGS += --dest-cpu=$(destCpu)
endif

ifeq (freebsd, $(destOs))
LDFLAGS += -lbsd
endif

# mips and fpu
# https://github.com/paul99/v8m-rb/issues/192
# https://bugs.debian.org/800410
# mips and big binaries
# http://gcc.gnu.org/wiki/DebugFission
# https://bugs.debian.org/829139

# use r2, which is the supported variant for these architectures
# https://lists.debian.org/debian-mips/2016/07/msg00000.html
ifeq (mipsel, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r2 --with-mips-fpu-mode=fpxx
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif
ifeq (mips, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r2 --with-mips-fpu-mode=fpxx
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif

# mips32r1 or greater, detected at runtime
ifeq (mips64el, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=rx --with-mips-fpu-mode=fp64
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif
ifeq (mips64r6el, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=rx --with-mips-fpu-mode=fp64
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif

ifeq (armel, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=softfp
ifeq ($(shell dpkg-vendor --is ubuntu && echo true),true)
# Ubuntu targets armv7+ with VFP and thumb2 support by default for armel
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3
else
# debian armel version
# v8 supports armv6k (must be set explicitely) + vfpv2 (selected by default)
# armv6k is only not available on ARM1136JF-S r0p2, and available on r1p0.
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv2 --with-arm-version=6
CFLAGS += -march=armv6k -mfpu=vfpv2
CPPFLAGS += -march=armv6k -mfpu=vfpv2
endif
endif

ifeq (armhf, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=hard
ifeq ($(shell dpkg-vendor --derives-from raspbian && echo true),true)
# enable vfp, disable armv7
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfp
else
# enable armv7 vfpv3-d16
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3-d16
endif
endif

DEB_DESTDIR = $(CURDIR)/debian/tmp
DEB_MAKE_CLEAN_TARGET = clean
DEB_MAKE_BUILD_TARGET = build

#  relax regression tests when targeted experimental suite
export HOME = $(CURDIR)/tmp
export FLAKY_TESTS = dontcare
export TEST_CI_ARGS = --arch=$(destCpu) --timeout=3000
export CI_JS_SUITES = message parallel sequential
export NODE_TEST_DIR = $(CURDIR)/tmp
export NODE_TEST_NO_INTERNET = 1
# needed for tests to avoid "ee key too small" errors
export OPENSSL_CONF = $(CURDIR)/deps/openssl/openssl/apps/openssl.cnf
# keep in mind ./debian/rules check is also invoked by adt-run, see debian/tests/
exp-relax-check := $(if $(shell dpkg-parsechangelog | grep -x 'Distribution: \(experimental\|UNRELEASED\)'),-i)
DEB_MAKE_CHECK_TARGET = $(exp-relax-check) test-ci-js

# build -fPIC
CFLAGS += -fPIC
CPPFLAGS += -fPIC

ifeq ($(DEB_HOST_ARCH_BITS),32)
CFLAGS += -g1
CPPFLAGS += -g1
DH_FLAGS += --max-parallel=1
export JOBS = 1
else
CFLAGS += -g
CPPFLAGS += -g
endif


# hardening gyp
CXXFLAGS += $(CPPFLAGS)

export CPPFLAGS
export CXXFLAGS
export CFLAGS
export LDFLAGS

export PYTHON = python3

%:
	dh $@ --with bash-completion $(DH_FLAGS)

# properly clean files from build, test, python
execute_after_dh_auto_clean:
	rm -f node_trace.1.log
	rm -f icu_config.gypi
	rm -rf test/addons/doc-*
	rm -f test/addons/.buildstamp
	rm -f test/addons/.docbuildstamp
	rm -rf test/addons/*/build
	rm -f config.gypi
	rm -f config.mk
	rm -f config.status
	rm -f test/fixtures/hello.txt
	rm -rf $(NODE_TEST_DIR)
	find . -name "*.pyc" -delete
	rm -rf out
	rm -rf node_modules
	rm -f debian/libnode$(ABI).install
	rm -f debian/libnode-dev.links
	rm -f debian/nodejs.install
	rm -f debian/nodejs.bash-completion

# remove *.json files from documentation
execute_after_dh_installdocs:
	find debian/nodejs-doc/usr/share/doc/nodejs-doc -name *.json -delete || true

override_dh_auto_configure:
# gyp    | debian
# -------+-------
# target | host
# host   | build

ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
	CC=$(CC) CXX=$(CXX) PKG_CONFIG=$(PKG_CONFIG) CC_host=$(CC_FOR_BUILD) CXX_host=$(CXX_FOR_BUILD) ./configure --cross-compiling $(DEB_CONFIGURE_EXTRA_FLAGS)
else
	./configure $(DEB_CONFIGURE_EXTRA_FLAGS)
endif

execute_before_dh_auto_build-arch:
	pkver=`dpkg-query --showformat='$${source:Upstream-Version}' --show node-acorn | sed -E 's/^([0-9]+\.[0-9]+\.[0-9]+).*/\1/g'`; \
	sed -i -e "s/[0-9]\+\.[0-9]\+\.[0-9]\+/$${pkver}/" src/acorn_version.h
	pkver=`dpkg-query --showformat='$${source:Upstream-Version}' --show node-cjs-module-lexer | sed -E 's/^([0-9]+\.[0-9]+\.[0-9]+).*/\1/g'`; \

## nodejs 18.19.1%2Bdfsg

=== deps/llhttp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1)
cmake_policy(SET CMP0069 NEW)

project(llhttp VERSION 6.1.0)
include(GNUInstallDirs)

set(CMAKE_C_STANDARD 99)

# By default build in relwithdebinfo type, supports both lowercase and uppercase
if(NOT CMAKE_CONFIGURATION_TYPES)
  set(allowableBuildTypes DEBUG RELEASE RELWITHDEBINFO MINSIZEREL)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "${allowableBuildTypes}")
  if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RELWITHDEBINFO CACHE STRING "" FORCE)
  else()
    string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE)
    if(NOT CMAKE_BUILD_TYPE IN_LIST allowableBuildTypes)
      message(FATAL_ERROR "Invalid build type: ${CMAKE_BUILD_TYPE}")
    endif()
  endif()
endif()

#
# Options
#
# Generic option
option(BUILD_SHARED_LIBS "Build shared libraries (.dll/.so)" ON)
option(BUILD_STATIC_LIBS "Build static libraries (.lib/.a)" OFF)

# Source code
set(LLHTTP_SOURCES
  ${CMAKE_CURRENT_SOURCE_DIR}/src/llhttp.c
  ${CMAKE_CURRENT_SOURCE_DIR}/src/http.c
  ${CMAKE_CURRENT_SOURCE_DIR}/src/api.c
)

set(LLHTTP_HEADERS
  ${CMAKE_CURRENT_SOURCE_DIR}/include/llhttp.h
)

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/libllhttp.pc.in
  ${CMAKE_CURRENT_SOURCE_DIR}/libllhttp.pc
  @ONLY
)

function(config_library target)
  target_sources(${target} PRIVATE ${LLHTTP_SOURCES} ${LLHTTP_HEADERS})

  target_include_directories(${target} PRIVATE
      ${CMAKE_CURRENT_SOURCE_DIR}/include
  )

  set_target_properties(${target} PROPERTIES
    OUTPUT_NAME llhttp
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
    PUBLIC_HEADER ${LLHTTP_HEADERS}
  )

  install(TARGETS ${target}
    EXPORT llhttp
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  )

  install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/libllhttp.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
  )

  # This is required to work with FetchContent
  install(EXPORT llhttp
        FILE llhttp-config.cmake
        NAMESPACE llhttp::
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/llhttp)
endfunction(config_library target)

if(BUILD_SHARED_LIBS)
  add_library(llhttp_shared SHARED
      ${llhttp_src}
  )
  add_library(llhttp::llhttp ALIAS llhttp_shared)
  config_library(llhttp_shared)
endif()

if(BUILD_STATIC_LIBS)
  add_library(llhttp_static STATIC
      ${llhttp_src}
  )
  if(BUILD_SHARED_LIBS)
    add_library(llhttp::llhttp ALIAS llhttp_shared)
  else()
    add_library(llhttp::llhttp ALIAS llhttp_static)
  endif()
  config_library(llhttp_static)
endif()

# On windows with Visual Studio, add a debug postfix so that release
# and debug libraries can coexist.
if(MSVC)
  set(CMAKE_DEBUG_POSTFIX "d")
endif()

# Print project configure summary
message(STATUS "")
message(STATUS "")
message(STATUS "Project configure summary:")
message(STATUS "")
message(STATUS "  CMake build type .................: ${CMAKE_BUILD_TYPE}")
message(STATUS "  Install prefix ...................: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "  Build shared library .............: ${BUILD_SHARED_LIBS}")
message(STATUS "  Build static library .............: ${BUILD_STATIC_LIBS}")
message(STATUS "")

## nodejs 18.19.1+dfsg

=== ada/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(ada
  DESCRIPTION "Fast spec-compliant URL parser"
  LANGUAGES C CXX
  VERSION 2.7.2
)

set(ADA_LIB_VERSION "2.7.2" CACHE STRING "ada library version")
set(ADA_LIB_SOVERSION "2" CACHE STRING "ada library soversion")

include(GNUInstallDirs)

include (cmake/clang-format.cmake)

include(CTest)
include(cmake/ada-flags.cmake)

set(ADA_SOURCE_DIR src)

add_subdirectory(src)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/scripts/cmake)

option(ADA_BENCHMARKS "Build benchmarks" OFF)

include(cmake/CPM.cmake)
# CPM requires git as an implicit dependency
find_package(Git QUIET)
# We use googletest in the tests
if(Git_FOUND AND BUILD_TESTING)
  CPMAddPackage(
    NAME GTest
    GITHUB_REPOSITORY google/googletest
    VERSION 1.14.0
    OPTIONS  "BUILD_GMOCK OFF" "INSTALL_GTEST OFF"
  )
endif()
# We use simdjson in both the benchmarks and tests
if(Git_FOUND AND (BUILD_TESTING OR ADA_BENCHMARKS))
  CPMAddPackage("gh:simdjson/simdjson@3.3.0")
endif()
# We use Google Benchmark, but it does not build under several 32-bit systems.
if(Git_FOUND AND ADA_BENCHMARKS AND (CMAKE_SIZEOF_VOID_P EQUAL 8))
  CPMAddPackage(
    NAME benchmark
    GITHUB_REPOSITORY google/benchmark
    GIT_TAG f91b6b4
    OPTIONS "BENCHMARK_ENABLE_TESTING OFF"
            "BENCHMARK_ENABLE_INSTALL OFF"
            "BENCHMARK_ENABLE_WERROR OFF"

  )
endif()

if (BUILD_TESTING AND NOT EMSCRIPTEN)
  if(Git_FOUND)
    message(STATUS "The tests are enabled.")
    add_subdirectory(tests)
  else()
    message(STATUS "The tests are disabled because git was not found.")
  endif()
else()
  if(is_top_project)
    message(STATUS "The tests are disabled.")
  endif()
endif(BUILD_TESTING AND NOT EMSCRIPTEN)

If(ADA_BENCHMARKS AND NOT EMSCRIPTEN)
  if(Git_FOUND)
    message(STATUS "Ada benchmarks enabled.")
    add_subdirectory(benchmarks)
  else()
    message(STATUS "The benchmarks are disabled because git was not found.")
  endif()
else(ADA_BENCHMARKS AND NOT EMSCRIPTEN)
  if(is_top_project)
    message(STATUS "Ada benchmarks disabled. Set ADA_BENCHMARKS=ON to enable them.")
  endif()
endif(ADA_BENCHMARKS AND NOT EMSCRIPTEN)

if (BUILD_TESTING AND EMSCRIPTEN)
  add_subdirectory(tests/wasm)
endif(BUILD_TESTING AND EMSCRIPTEN)

add_library(ada::ada ALIAS ada)

set_target_properties(
  ada PROPERTIES
  VERSION "${ADA_LIB_VERSION}"
  SOVERSION "${ADA_LIB_SOVERSION}"
  WINDOWS_EXPORT_ALL_SYMBOLS YES
)

include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

if(NOT ADA_COVERAGE AND NOT EMSCRIPTEN)
  add_subdirectory(singleheader)
endif()

if(ADA_TOOLS)
  if(Git_FOUND)
    add_subdirectory(tools)
  else()
    message(STATUS "The tools are disabled because git was not found.")
  endif()
endif()

install(
  FILES include/ada.h include/ada_c.h
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
  COMPONENT ada_development
)

install(
  DIRECTORY include/ada
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
  COMPONENT ada_development
)

install(
  TARGETS ada
  EXPORT ada_targets
  RUNTIME COMPONENT ada_runtime
  LIBRARY COMPONENT ada_runtime
  NAMELINK_COMPONENT ada_development
  ARCHIVE COMPONENT ada_development
  INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
)

configure_file(cmake/ada-config.cmake.in ada-config.cmake @ONLY)

write_basic_package_version_file(
  ada-config-version.cmake
  COMPATIBILITY SameMinorVersion
)

set(
  ADA_INSTALL_CMAKEDIR "${CMAKE_INSTALL_LIBDIR}/cmake/ada"
  CACHE STRING "CMake package config location relative to the install prefix"
)
mark_as_advanced(ADA_INSTALL_CMAKEDIR)

install(
  FILES
  "${PROJECT_BINARY_DIR}/ada-config.cmake"
  "${PROJECT_BINARY_DIR}/ada-config-version.cmake"
  DESTINATION "${ADA_INSTALL_CMAKEDIR}"
  COMPONENT ada_development
)

install(
  EXPORT ada_targets
  NAMESPACE ada::
  DESTINATION "${ADA_INSTALL_CMAKEDIR}"
  COMPONENT ada_development
)

install(
  EXPORT ada_targets
  NAMESPACE ada::
  DESTINATION "${ADA_INSTALL_CMAKEDIR}"
  COMPONENT example_development
)

if(is_top_project)
  set(CPACK_PACKAGE_VENDOR "Ada Authors")
  set(CPACK_PACKAGE_CONTACT "yagiz@nizipli.com")
  set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE-MIT")
  set(CPACK_RPM_PACKAGE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE-MIT")
  set(CPACK_RESOURCE_FILE_README "${PROJECT_SOURCE_DIR}/README.md")
  set(CPACK_SOURCE_GENERATOR "TGZ;ZIP")
  include(CPack)
endif()

=== singleheader/CMakeLists.txt ===
#
# Amalgamation
#
set(SINGLEHEADER_FILES
  ${CMAKE_CURRENT_BINARY_DIR}/ada.cpp
  ${CMAKE_CURRENT_BINARY_DIR}/ada.h
  ${CMAKE_CURRENT_BINARY_DIR}/ada_c.h
  ${CMAKE_CURRENT_BINARY_DIR}/demo.cpp
  ${CMAKE_CURRENT_BINARY_DIR}/demo.c
  ${CMAKE_CURRENT_BINARY_DIR}/README.md
)
set_source_files_properties(${SINGLEHEADER_FILES} PROPERTIES GENERATED TRUE)

# In theory, this is unneeded, because the tests module does the same test:
find_package (Python3 COMPONENTS Interpreter)

if (Python3_Interpreter_FOUND)
  MESSAGE( STATUS "Python found, we are going to amalgamate.py." )

  add_custom_command(
    OUTPUT ${SINGLEHEADER_FILES}
    COMMAND ${CMAKE_COMMAND} -E env
      AMALGAMATE_SOURCE_PATH=${PROJECT_SOURCE_DIR}/src
      AMALGAMATE_INPUT_PATH=${PROJECT_SOURCE_DIR}/include
      AMALGAMATE_OUTPUT_PATH=${CMAKE_CURRENT_BINARY_DIR}
      ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/amalgamate.py
      #
      # This is the best way I could find to make amalgamation trigger whenever source files or
      # header files change: since the "ada" library has to get rebuilt when that happens, we
      # take a dependency on the generated library file (even though we're not using it). Depending
      # on ada-source doesn't do the trick because DEPENDS here can only depend on an
      # *artifact*--it won't scan source and include files the way a concrete library or executable
      # will.
      #
      # It sucks that we have to build the actual library to make it happen, but it's better than\
      # nothing!
      #
      DEPENDS amalgamate.py ada
  )
  add_custom_target(ada-singleheader-files DEPENDS ${SINGLEHEADER_FILES})

  #
  # Include this if you intend to #include "ada.cpp" in your own .cpp files.
  #
  add_library(ada-singleheader-include-source INTERFACE)
  target_include_directories(ada-singleheader-include-source INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>)
  add_dependencies(ada-singleheader-include-source ada-singleheader-files)

  add_library(ada-singleheader-source INTERFACE)
  target_sources(ada-singleheader-source INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/ada.cpp>)
  target_link_libraries(ada-singleheader-source INTERFACE ada-singleheader-include-source)
  add_library(ada-singleheader-lib STATIC $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/ada.cpp>)

  if (BUILD_TESTING)
    add_executable(demo $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/demo.cpp>)
    target_link_libraries(demo ada-singleheader-include-source)

    add_test(demo demo)

    add_executable(cdemo $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/demo.c>)
    target_link_libraries(cdemo ada-singleheader-lib)
    add_test(cdemo cdemo)
  endif()
else()
  MESSAGE( STATUS "Python not found, we are unable to test amalgamate.py." )
endif()

=== src/CMakeLists.txt ===

message(STATUS "Compiler ID : " ${CMAKE_CXX_COMPILER_ID})
message(STATUS "CMAKE_BUILD_TYPE : " ${CMAKE_BUILD_TYPE})

add_library(ada-include-source INTERFACE)
target_include_directories(ada-include-source INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)
add_library(ada-source INTERFACE)
target_sources(ada-source INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>/ada.cpp)
target_link_libraries(ada-source INTERFACE ada-include-source)
add_library(ada ada.cpp)
target_include_directories(ada PRIVATE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}> )
target_include_directories(ada PUBLIC "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>")

if(MSVC)
  if("${MSVC_TOOLSET_VERSION}" STREQUAL "140")
    target_compile_options(ada INTERFACE /W0 /sdl)
    set(ADA_LEGACY_VISUAL_STUDIO TRUE)
  else()
    target_compile_options(ada INTERFACE /WX /W3 /sdl /w34714) # https://docs.microsoft.com/en-us/cpp/error-messages/compiler-warnings/compiler-warning-level-4-c4714?view=vs-2019
  endif()
else(MSVC)
  if(NOT WIN32)
    target_compile_options(ada INTERFACE -fPIC)
  endif()
  message(STATUS "Assuming GCC-like compiler.")
  target_compile_options(ada PRIVATE -Wall -Wextra -Weffc++)
  if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options(ada PRIVATE -Wsuggest-override)
  endif()
  if((CMAKE_CXX_COMPILER_ID STREQUAL "Clang") OR (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang"))
    target_compile_options(ada PRIVATE -Winconsistent-missing-override)
  endif()
  target_compile_options(ada PRIVATE -Wfatal-errors -Wsign-compare -Wshadow -Wwrite-strings -Wpointer-arith -Winit-self -Wconversion -Wno-sign-conversion)
endif(MSVC)

# workaround for GNU GCC poor AVX load/store code generation
if ((CMAKE_CXX_COMPILER_ID STREQUAL "GNU") AND (CMAKE_SYSTEM_PROCESSOR MATCHES "^(i.86|x86(_64)?)$"))
  target_compile_options(ada PRIVATE -mno-avx256-split-unaligned-load -mno-avx256-split-unaligned-store)
endif()
if(ADA_DEVELOPMENT_CHECKS)
  target_compile_definitions(ada PUBLIC ADA_DEVELOPMENT_CHECKS=1)
endif()
if((CMAKE_CXX_COMPILER_ID STREQUAL "GNU") AND (CMAKE_BUILD_TYPE STREQUAL "Debug"))
  message(STATUS "Enabling _GLIBCXX_DEBUG")
  target_compile_definitions(ada PRIVATE _GLIBCXX_DEBUG=1)
endif()

if(ADA_SANITIZE)
  target_compile_options(ada INTERFACE -fsanitize=address  -fno-omit-frame-pointer -fno-sanitize-recover=all)
  target_compile_definitions(ada INTERFACE ASAN_OPTIONS=detect_leaks=1)
  target_link_libraries(ada INTERFACE -fsanitize=address  -fno-omit-frame-pointer -fno-sanitize-recover=all)
endif()

if(ADA_LOGGING)
  target_compile_definitions(ada PRIVATE ADA_LOGGING=1)
endif()

=== tests/CMakeLists.txt ===
add_subdirectory(wpt)

set(ADA_TEST_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../)
if(MSVC)
  add_compile_options("/Zi" "/EHsc" "/GR")
  add_compile_options("$<$<C_COMPILER_ID:MSVC>:/utf-8>")
  add_compile_options("$<$<CXX_COMPILER_ID:MSVC>:/utf-8>")
endif()

include(${PROJECT_SOURCE_DIR}/cmake/add-cpp-test.cmake)
link_libraries(ada)

add_cpp_test(basic_fuzzer)

if(MSVC AND BUILD_SHARED_LIBS)
  # Copy the ada dll into the directory
  add_custom_command(TARGET basic_fuzzer PRE_BUILD        # Adds a pre-build event
    COMMAND ${CMAKE_COMMAND} -E copy_if_different  # which executes "cmake -E copy_if_different..."
        "$<TARGET_FILE:ada>"      # <--this is in-file
        "$<TARGET_FILE_DIR:basic_fuzzer>")                 # <--this is out-file path
endif()

if(MSVC AND BUILD_SHARED_LIBS)
  message(STATUS "For some tests we use Google Test and it fails when building a DLL.")
  message(STATUS "Thus the tests are disabled. Sorry.")
else()
  include(GoogleTest)
  add_executable(wpt_tests wpt_tests.cpp)
  add_executable(url_components url_components.cpp)
  add_executable(basic_tests basic_tests.cpp)
  add_executable(from_file_tests from_file_tests.cpp)
  add_executable(ada_c ada_c.cpp)
  add_executable(url_search_params url_search_params.cpp)

  target_link_libraries(wpt_tests PRIVATE simdjson GTest::gtest_main)
  target_link_libraries(url_components PRIVATE simdjson GTest::gtest_main)
  target_link_libraries(basic_tests PRIVATE simdjson GTest::gtest_main)
  target_link_libraries(from_file_tests PRIVATE simdjson GTest::gtest_main)
  target_link_libraries(ada_c PRIVATE simdjson GTest::gtest_main)
  target_link_libraries(url_search_params PRIVATE simdjson GTest::gtest_main)

  gtest_discover_tests(wpt_tests)
  gtest_discover_tests(url_components)
  gtest_discover_tests(basic_tests)
  gtest_discover_tests(from_file_tests)
  gtest_discover_tests(ada_c)
  gtest_discover_tests(url_search_params)

  if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9)
      target_link_libraries(wpt_tests PUBLIC stdc++fs)
      target_link_libraries(url_components PUBLIC stdc++fs)
      target_link_libraries(url_search_params PUBLIC stdc++fs)
    endif()
  endif()

  if(MSVC OR MINGW)
    target_compile_definitions(wpt_tests PRIVATE _CRT_SECURE_NO_WARNINGS)
    target_compile_definitions(url_components PRIVATE _CRT_SECURE_NO_WARNINGS)
    target_compile_definitions(basic_fuzzer PRIVATE _CRT_SECURE_NO_WARNINGS)
    target_compile_definitions(from_file_tests PRIVATE _CRT_SECURE_NO_WARNINGS)
    target_compile_definitions(basic_tests PRIVATE _CRT_SECURE_NO_WARNINGS)
    target_compile_definitions(url_search_params PRIVATE _CRT_SECURE_NO_WARNINGS)
  endif()

endif()

=== tools/release/requirements.txt ===
PyGithub==2.1.1
pytest==7.4.2

=== debian/changelog ===
nodejs (18.19.1+dfsg-6ubuntu5) noble; urgency=medium

  * d/t/control: Drop the python3-distutils dependency (LP: #2061946)

 -- Pushkar Kulkarni <pushkar.kulkarni@canonical.com>  Thu, 18 Apr 2024 21:08:10 +0200

nodejs (18.19.1+dfsg-6ubuntu4) noble; urgency=medium

  * No-change rebuild against libcares2 and bootstrap build.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 17 Apr 2024 19:21:45 +1200

nodejs (18.19.1+dfsg-6ubuntu3) noble; urgency=medium

  * No-change rebuild against libcares2.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Tue, 16 Apr 2024 22:46:24 +1200

nodejs (18.19.1+dfsg-6ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 20:15:53 +0000

nodejs (18.19.1+dfsg-6ubuntu1) noble; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Still use Ubuntu openssl patch and approach, the Debian one
      makes testsuite fail.
    - Fix offset by one in one new test due to additional openssl conf
      file passed as parameter
    - Add 2 new flaky tests, regressed in release
    - a709a7e0c5461583f0f8a0dc2e92e3698e8fc2da.patch,
      95534ad82f4e33f53fd50efe633d43f8da70cba6.patch,
      d1ccca9d2bd913194a70beb762876f46e46060a0.patch,
      6557c1c9b1206a85bb7d8e7450e8c3a4cff7c84b.patch
      cherry-pick fix for Python3.12

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 16 Mar 2024 07:14:59 +0100

nodejs (18.19.1+dfsg-6) unstable; urgency=medium

  * Source-only upload 

 -- Jérémy Lal <kapouer@melix.org>  Sat, 16 Mar 2024 01:37:07 +0100

nodejs (18.19.1+dfsg-5) unstable; urgency=medium

  * Drop distutils dep. Closes: #1065909
  * Facilitate t64 transition by just bumping
    NODE_MODULE ABI to 109. Closes: #1066399
  * test_ci.patch: skip hanging or EAI_AGAIN failing tests

 -- Jérémy Lal <kapouer@melix.org>  Thu, 14 Mar 2024 23:51:57 +0100

nodejs (18.19.1+dfsg-4ubuntu2) noble; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Still use Ubuntu openssl patch and approach, the Debian one
      makes testsuite fail.
    - Fix offset by one in one new test due to additional openssl conf
      file passed as parameter
    - Add 2 new flaky tests, regressed in release
    - a709a7e0c5461583f0f8a0dc2e92e3698e8fc2da.patch,
      95534ad82f4e33f53fd50efe633d43f8da70cba6.patch,
      d1ccca9d2bd913194a70beb762876f46e46060a0.patch,
      6557c1c9b1206a85bb7d8e7450e8c3a4cff7c84b.patch
      cherry-pick fix for Python3.12
    - drop python3-distutils B-D (thanks <tumbleweed>)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 09 Mar 2024 15:05:38 +0100

nodejs (18.19.1+dfsg-4) unstable; urgency=medium

  * ABIt64: drop libnode108t64.install. Closes: #1065510.

 -- Jérémy Lal <kapouer@melix.org>  Wed, 06 Mar 2024 16:26:37 +0100

nodejs (18.19.1+dfsg-3.1ubuntu2) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 20:11:04 +0000

nodejs (18.19.1+dfsg-3.1ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Still use Ubuntu openssl patch and approach, the Debian one
      makes testsuite fail.
    - Fix offset by one in one new test due to additional openssl conf
      file passed as parameter
    - Add 2 new flaky tests, regressed in release
    - a709a7e0c5461583f0f8a0dc2e92e3698e8fc2da.patch,
      95534ad82f4e33f53fd50efe633d43f8da70cba6.patch,
      d1ccca9d2bd913194a70beb762876f46e46060a0.patch,
      6557c1c9b1206a85bb7d8e7450e8c3a4cff7c84b.patch
      cherry-pick fix for Python3.12

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 29 Feb 2024 17:30:04 +0100

nodejs (18.19.1+dfsg-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1064251

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 22:55:34 +0000

nodejs (18.19.1+dfsg-3) unstable; urgency=medium

  * mips64el: skip failing test
    Some unusual v8 options make mips64el crash

 -- Jérémy Lal <kapouer@melix.org>  Thu, 22 Feb 2024 11:36:42 +0100

nodejs (18.19.1+dfsg-2ubuntu4) noble; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Still use Ubuntu openssl patch and approach, the Debian one
      makes testsuite fail.
    - Fix offset by one in one new test due to additional openssl conf
      file passed as parameter
    - Add 2 new flaky tests, regressed in release
    - a709a7e0c5461583f0f8a0dc2e92e3698e8fc2da.patch,
      95534ad82f4e33f53fd50efe633d43f8da70cba6.patch,
      d1ccca9d2bd913194a70beb762876f46e46060a0.patch,
      6557c1c9b1206a85bb7d8e7450e8c3a4cff7c84b.patch
      cherry-pick fix for Python3.12

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 21 Feb 2024 15:23:09 +0100

nodejs (18.19.1+dfsg-2) unstable; urgency=medium

  [ Bo YU ]
  * Allow more risc64 tests to fail. Closes: #1064331

  [ Jérémy Lal ]
  * Allow more mips64el tests to fail. Closes: #1064306
    Upstream still supports those architectures but they
    take more time to fix corner cases.

 -- Jérémy Lal <kapouer@melix.org>  Tue, 20 Feb 2024 11:56:31 +0100

nodejs (18.19.1+dfsg-1) unstable; urgency=medium

  * New upstream version 18.19.1. Closes: 1064055.
    + CVE-2024-21892 (High)
      Code injection and privilege escalation through Linux capabilities
    + CVE-2024-22019 (High)
      Reading unprocessed HTTP request with unbounded chunk
      extension allows DoS attacks
    + CVE-2023-46809 (Medium)
      Marvin Attack vulnerability against PKCS#1 v1.5 padding
  * new architecture: loong64, thanks to Shi Pujin  
  * patch:
    + let loong64 have some failing tests
    + more doc for localhost-no-addrconfig
    + allow test-debugger-heap-profiler to fail. Closes: #1059168
    + disable zlib embedding in v8, disable snapshot compression
  * override lintian source warning for zlib brotli test string
  * fix boostrapping of nodejs package:


=== debian/control ===
Source: nodejs
Section: javascript
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@alioth-lists.debian.net>
Uploaders: Jérémy Lal <kapouer@melix.org>,
 Jonas Smedegaard <dr@jones.dk>
Build-Depends: dpkg-dev (>= 1.22.5),
 sse2-support [i386] <!nocheck>,
 armv6k-support [armel] <!nocheck>, vfpv2-support [armel] <!nocheck>,
 debhelper-compat (= 13),
 dh-buildinfo,
 bash-completion,
 ca-certificates,
 curl <!nocheck>,
 gyp (>= 0.1~svn1773),
 jq,
 libbrotli-dev,
 libbrotli-dev:native,
 libc-ares-dev (>= 1.18.1~),
 libc-ares-dev:native,
 libhttp-parser-dev (>= 2.9.2~),
 libicu-dev (>= 70.1~),
 libicu-dev:native,
 libkvm-dev [kfreebsd-any],
 libnghttp2-dev (>= 1.41.0~),
 libnghttp2-dev:native,
 libssl-dev (>= 1.1.1~),
 libssl-dev:native,
 libuv1-dev (>= 1.43.0~),
 libuv1-dev:native,
 node-acorn (>= 6.2.1~) <!pkg.nodejs.nobuiltin>,
 node-cjs-module-lexer (>= 1.2.2~) <!pkg.nodejs.nobuiltin>,
 node-undici (>= 5.0.0~) <!pkg.nodejs.nobuiltin>,
 openssl (>= 1.1.1~) <!nocheck>,
 pkgconf,
 pkg-js-tools (>= 0.8.2~) <!nocheck>,
 python3:native,
 procps <!nocheck>,
 zlib1g-dev,
 zlib1g-dev:native,
Build-Depends-Indep:
 node-js-yaml (>= 4.1.0+dfsg+~4.0.5-6) <!nodoc>,
 node-marked (>= 4~) <!nodoc>,
 node-highlight.js <!nodoc>,
Standards-Version: 4.6.2
Homepage: https://nodejs.org/
Vcs-Browser: https://salsa.debian.org/js-team/nodejs/tree/master-18.x
Vcs-Git: https://salsa.debian.org/js-team/nodejs.git -b master-18.x
Rules-Requires-Root: no

Package: libnode-dev
Section: libdevel
Architecture: amd64 arm64 armel armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel loong64 powerpc ppc64 ppc64el riscv64 s390x
Depends: ${misc:Depends},
 libssl-dev (>= 1.1.1~),
 libuv1-dev (>= 1.33.0~),
 libnode109 (= ${binary:Version})
Breaks: nodejs-dev (<< 10.0.0~dfsg1-3)
Replaces: libv8-dev,
 nodejs-dev (<< 10.0.0~dfsg1-3)
Conflicts: libv8-dev (<= 3.14.5.8-11)
Provides: libv8-dev
Description: evented I/O for V8 javascript (development files)
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 This package provides development headers for libnode109.

Package: nodejs
Architecture: amd64 arm64 armel armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel loong64 powerpc ppc64 ppc64el riscv64 s390x
Multi-Arch: allowed
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 sse2-support [i386],
 armv6k-support [armel], vfpv2-support [armel],
 libnode109 (= ${binary:Version})
Recommends: ca-certificates,
 nodejs-doc
Suggests: npm
Replaces: nodejs-legacy
 , libnode72 (<< 13)
 , libnode83 (<< 16.13.2+really14.19.1~dfsg~)
Conflicts: nodejs-legacy
Breaks: node-typescript-types (<< 20210110~)
 , node-babel-runtime (<< 7)
 , node-jest (<< 29~)
 , libnode72 (<< 13)
 , libnode83 (<< 16.13.2+really14.19.1~dfsg~)
Provides: node-types-node (= ${types:Node})
Description: evented I/O for V8 javascript - runtime executable
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.

Package: libnode109
Provides: ${t64:Provides}
Section: libs
Architecture: amd64 arm64 armel armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel loong64 powerpc ppc64 ppc64el riscv64 s390x
Multi-Arch: same
Depends: ${shlibs:Depends},
 ${misc:Depends},
 sse2-support [i386],
 armv6k-support [armel], vfpv2-support [armel],
 node-acorn (>= 6.2.1~) <!pkg.nodejs.nobuiltin>,
 node-cjs-module-lexer (>= 1.2.2~) <!pkg.nodejs.nobuiltin>,
 node-undici (>= 5.0.0~) <!pkg.nodejs.nobuiltin>
Breaks: libnode109 (<< ${source:Version}), node-modern-syslog (<< 1.1.4-2),
 libnode64 (<< 10.24.1~),
 libnode72 (<< 13)
Replaces: nodejs-legacy, libnode72, libnode83, libnode93, libnode108
Conflicts: nodejs-legacy
Description: evented I/O for V8 javascript - runtime library
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 .
 This package provides the dynamic library for Node.js.

Package: nodejs-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Recommends: nodejs
Depends: ${misc:Depends}
Replaces: nodejs (<< 6.11.2~dfsg-3)
Conflicts: nodejs (<< 6.11.2~dfsg-3)
Description: API documentation for Node.js, the javascript platform
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 .
 This package contains API documentation for Node.js.

=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,7 @@
 ABI = $(shell awk '/^#define NODE_MODULE_VERSION/ {print $$3}' src/node_version.h)
 
 # archs
-ARCHS := amd64 arm64 armel armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el riscv64 s390x
+ARCHS := amd64 arm64 armel armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel loong64 ppc64 ppc64el riscv64 s390x
 
 # branch
 BRANCH := $(word 1, $(subst .,$(space), $(DEB_UPSTREAM_VERSION)))
@@ -63,6 +63,7 @@
 destCpu := $(or $(destCpu),$(if $(filter mips64el,$(DEB_HOST_ARCH)),mips64el))
 destCpu := $(or $(destCpu),$(if $(filter mips64r6el,$(DEB_HOST_ARCH)),mips64el))
 destCpu := $(or $(destCpu),$(if $(filter mips,$(DEB_HOST_ARCH)),mips))
+destCpu := $(or $(destCpu),$(if $(filter loong64,$(DEB_HOST_ARCH)),loong64))
 destCpu := $(or $(destCpu),$(if $(filter powerpc,$(DEB_HOST_ARCH)),ppc))
 destCpu := $(or $(destCpu),$(if $(filter ppc64,$(DEB_HOST_ARCH)),ppc64))
 destCpu := $(or $(destCpu),$(if $(filter riscv64,$(DEB_HOST_ARCH)),riscv64))
@@ -152,7 +153,7 @@
 #  relax regression tests when targeted experimental suite
 export HOME = $(CURDIR)/tmp
 export FLAKY_TESTS = dontcare
-export TEST_CI_ARGS = --arch=$(destCpu) --timeout=3000
+export TEST_CI_ARGS = --arch=$(destCpu) --timeout=3000 --node-args="--openssl-shared-config"
 export CI_JS_SUITES = message parallel sequential
 export NODE_TEST_DIR = $(CURDIR)/tmp
 export NODE_TEST_NO_INTERNET = 1
@@ -230,4 +231,3 @@
 execute_before_dh_auto_build-arch:
 	pkver=`dpkg-query --showformat='$${source:Upstream-Version}' --show node-acorn | sed -E 's/^([0-9]+\.[0-9]+\.[0-9]+).*/\1/g'`; \
 	sed -i -e "s/[0-9]\+\.[0-9]\+\.[0-9]\+/$${pkver}/" src/acorn_version.h
-	pkver=`dpkg-query --showformat='$${source:Upstream-Version}' --show node-cjs-module-lexer | sed -E 's/^([0-9]+\.[0-9]+\.[0-9]+).*/\1/g'`; \

=== debian/watch ===
version=4
opts=downloadurlmangle=s/.*v(.*)\//https\:\/\/nodejs\.org\/dist\/v$1\/node\-v$1\.tar\.xz/,\
filenamemangle=s/.*v(.*)\/$/nodejs-$1\.tar\.xz/,\
dversionmangle=auto,\
repacksuffix=+dfsg \
https://nodejs.org/dist v(18\.\d+\.\d+)/ group

# It is not recommended use npmregistry. Please investigate more.
# Take a look at https://wiki.debian.org/debian/watch/
opts="searchmode=plain,ctype=nodejs,component=types-node,pgpmode=none" \
 https://registry.npmjs.org/@types/node https://registry.npmjs.org/@types/node/-/node-(18[\d\.]+)@ARCHIVE_EXT@ ignore

opts="component=ada,filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%ada-$1$2%" \
 https://github.com/ada-url/ada/tags?after=v2.7.3 \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@ ignore

## nodejs 18.20.4%2Bdfsg

=== tools/release/requirements.txt ===
PyGithub==2.3.0
pytest==8.1.1
